package com.eactive.eai.batch.job.jobItem.house;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.util.HashMap;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_HOUSE_0300 extends DefaultTelegram implements TelegramService {

    private int     SEQUENCE_NO;
    private int     SEND_LENGTH;        //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int     REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이
    private int     MISSING_COUNT;     //결번갯수
    private String  MISSING_FIELD;
    
    private Properties telegramInfo;
    private File file;
    private FileOutputStream fout;

    /**
     * 생성자
     */
    public SEND_HOUSE_0300() {
        //결번확인통보
        MISSING_COUNT = 0;
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
        	
            SEQUENCE_NO = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            boolean result = calculateMissingCount();
            if (!result) return false;

            result = calculateSendLength();
            if (!result) return false;

            //아데나 장비를 위한 전문 길이 필드
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            //Transaction Code - 해당 Transaction을 기동하는 코드. LU가 구분 되어 있을 것으로 예상
            // 모기지론 유동화 자료 - HR00FTP
            // 주택위탁보증 자료     - HW00FTP
            // 학자금 유동화 자료    - SR00FTP
            // 학자금위탁보증 자료  - SW00FTP
            // U보금자리                 - BM00FTP/BM01FTP
            compileField(1, batchDoc.getBatchMsg().getHeader().getTRXID(), this.al_FieldProps[1]);
            
            //업무구분코드 - 업무구분을 위하여 Set하는 문자로 본 파일전송 업무에서는 “FTP”문자를 사용키로 한다.
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);
            
            //대표기관코드 - 전문관련 대외기관을 나타내는 코드로서 세부사항은 표준화 사항의 대외기관코드를 참조한다.
            // Ex) 국민: 004, 부산: 032, 농협: 011 등
            compileField(3, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[3]);
            
            //전문종별코드 - 전문의 기능을 나타내는 구분코드로 전문종류별로 해당 전문코드를 Set하며 세부사항은 표준화 사항의 전문종별 코드를 참조한다.
            compileField(4, this.getFldTelegramType(), this.al_FieldProps[4]);
            
            //거래구분코드 - 각 업무 및 화일의 종류를 구분하기 위한 코드로 구성되며 세부내용은 표준화 사항을 참조한다.
            compileField(5, batchDoc.getBatchMsg().getHeader().getBizCode(), this.al_FieldProps[5]);

            //송수신 FLAG - 전문을 발생시킨 기관을 나타내는 코드로 아래의 값중 해당코드를 Set한다.
            // “C” : 한국주택금융공사에서 전문을 발생할 시
            // “B” : 위탁기관에서 전문을 발생할 시
            compileField(6, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[6]);
            
            //응답코드 - 전문의 처리 결과를 나타내는 응답코드로 세부내용은 표준화 사항의 응답코드를 참조한다.
            compileField(7, this.getResolveResponseCode(), this.al_FieldProps[7]);
            
            //일자 (자료기준일자) - 은행에서 자료보고(위탁기관→주택금융공사) 및 주택금융공사자료통보(주택금융공사→위탁기관) 시에는 자료의 기준일자를 Set한다.
            compileField(8, batchDoc.getBatchMsg().getHeader().getBaseDate(), this.al_FieldProps[8]);
            
            //업무별 Record Length -송수신을 하고자 하는 자료의 Record Length를 Set 한다.
            compileField(9, ""+batchDoc.getBatchMsg().getHeader().getRecLen(), this.al_FieldProps[9]);
            
            //전체 전문 길이
            //공통부와 업무정보부를 합한  전체길이.
            //프로토콜이 TCP/IP 인 경우만 Set 한다.
            //compileField(10, ""+SEND_LENGTH, this.al_FieldProps[10]);
            compileField(10, "0", this.al_FieldProps[10]);
            
            //송수신 업무 구분코드. 한국주택금융공사를 기준으로 하여 해당전문이 송.수신업무 중 어느 업무에 관련된 것인지를 구분하기 위한 코드로 아래값 중 해당코드를 Set한다.
            //“S”  :  화일 송신업무 관련 전문 (한국주택금융공사→위탁기관)
            //“R”  :  화일 수신업무 관련 전문 (위탁기관→한국주택금융공사)
            compileField(11, getFldTrClass() , this.al_FieldProps[11]);

            //Block-NO
            compileField(12, ""+this.batchDoc.getBatchMsg().getBody().getBlockNum() , this.al_FieldProps[12]);

            //Sequence-NO
            compileField(13, ""+SEQUENCE_NO , this.al_FieldProps[13]);

            //결번갯수
            compileField(14, ""+MISSING_COUNT, this.al_FieldProps[14]);
            
            //<< 전문 완성
            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
            // 20060413 add by khs
            if (MISSING_COUNT==0) {
                fout.close();
                int block_no = batchDoc.getBatchMsg().getBody().getBlockNum();
                batchDoc.getBatchMsg().getBody().setBlockNum(block_no + 1);
            }
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<11; i++) { //한국주택금융공사 전문의 헤더는 레코드 길이까지 임.
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=11; i< al_Field.size(); i++) {  //결번확인 필드는 비정형 필드로 바디 로그에서 제외
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }


    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
                //여기에서 파일을 연다.
               return MISSING_FIELD.length();
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * return value : 0 no left data to be sent
     *                -1 error
     *                >0 data copied to the data field
     *
     * 비정형 필드인 결번확인의 데이터를 얻어낸다.
     * 결번확인 데이터를 실어주고 결번확인 필드의 길이를 반환한다.
     */
    public int getInformalFieldSendData(int idx, byte[] data) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{}  getInformalFieldSendData> " +idx+ " is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < MISSING_FIELD.length()) {
                logger.debug("{}  getInformalFieldSendData> InformalFieldSendData size is bigger than buffer size", logHeader);
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            //mod by khs data = MISSING_FIELD.getBytes();
            ByteArrayInputStream bin = new ByteArrayInputStream(MISSING_FIELD.getBytes());
            bin.read(data, 0, MISSING_FIELD.length());
            return MISSING_FIELD.length();
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }

    private boolean calculateSendLength () {
        try {
            for (int i=1; i< this.al_Field.size()-1; i++) { //마지막 결번확인은 가변길이
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += MISSING_FIELD.length();  //비정형 필드인 결번확인의 길이 더함.
            REAL_SEND_LENGTH = SEND_LENGTH;
            REAL_SEND_LENGTH += ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }

        return true;
    }

    private boolean calculateMissingCount () {
        try {

            String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
            int seq_no = this.batchDoc.getBatchMsg().getBody().getSeqNum();

            JobProcessData job = JobProcessData.getInstance();
            HashMap<String, Object> hm = job.getBatchStageData(uuid);

            @SuppressWarnings("unchecked")
			HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>)hm.get(JobProcessData.PROCDATA_BLOCKDATA);

            byte[] _missingNm = new byte[seq_no];
            for (int i=0; i<seq_no; i++) {
                _missingNm[i] = '1';    //모든 결번은 1로 초기화
            }

            for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인
                //20060413 khs >>  byte[] data = (byte[]) block_data.get( i );
                byte[] data = null;
                if ( block_data != null ){
                	data = (byte[]) block_data.get( new Integer(i) );
                }
                if (data == null ) {
                    _missingNm[i] = '0';    //결번이 발생한 seq만 '0' 설정
                    MISSING_COUNT++;
                    logger.info("{} calculateMissingCount >> missing telegram : [" + i + "]", logHeader);
                }
            }

            if (MISSING_COUNT == 0) {
                if (!createFile()) {
                    return false;
                }

                for (int i = 0; i<seq_no; i++) {        //받은 seq_no만큼만 데이터 확인하여 기록
                    byte[] data = null;
                    if ( block_data != null ){
                    	data = (byte[]) block_data.get( new Integer(i) );
                    }
            		int recLen = batchDoc.getBatchMsg().getHeader().getRecLen();
                    if ( recLen < 1 ){
                    	recLen = data.length;
                    }
            		byte[]layout = new byte[recLen];
            		for (int inx = 0; inx < layout.length; inx++) {
						layout[inx] = ' ';
					}

            		int dataCnt =(data != null) ? data.length / recLen : 0; // data.length / recLen ; // 20250910 npe
            		for (int jnx = 0; jnx < dataCnt; jnx++) {
                		System.arraycopy( data,jnx*layout.length,layout,0,layout.length);
                        fout.write(layout);
                        fout.write( '\n' );
                        long lnCurSize = batchDoc.getBatchMsg().getBody().getCurFileSize()+recLen;
                        batchDoc.getBatchMsg().getBody().setCurFileSize(lnCurSize);
					}

                }
                hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    //데이터 기록후 HashMap 초기화
            }

            this.MISSING_FIELD = new String (_missingNm);
            this.batchDoc.getBatchMsg().getBody().setMissingNmCount(MISSING_COUNT);
            this.batchDoc.getBatchMsg().getBody().setMissingNmField(MISSING_FIELD);

        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI027";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    private boolean createFile () {
        try {
            String strFullPath = batchDoc.getBatchMsg().getHeader().getFilePath();
            if (strFullPath.charAt(strFullPath.length()-1) != File.separatorChar) {
                strFullPath = strFullPath + File.separator;
            }
            strFullPath = strFullPath + batchDoc.getBatchMsg().getHeader().getFileName();
            logger.info("{}  getCalculatedLength >> File full-path [" + strFullPath + "]", logHeader);
            file = new File(strFullPath);
            fout = new FileOutputStream(file, true);   //bytes will be written to the end of the file rather than the beginning
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI028";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(11);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
		return super.getOpCode();
    }
}
